package com.ibm.oti.reflect;

/*
 * Licensed Materials - Property of IBM,
 *     Copyright IBM Corp. 2005, 2010  All Rights Reserved
 */

import java.lang.annotation.Annotation;
import java.lang.ref.SoftReference;

public class Method {
	private java.lang.reflect.Method method;
	private SoftReference<Annotations> annotations;
	private SoftReference<Object> srDefaultValue;

public Method(java.lang.reflect.Method method) {
	this.method = method;
}

private synchronized Annotations getAnnotations() {
	Annotations ans;
	if (annotations == null || (ans = annotations.get()) == null) {
		annotations = new SoftReference<Annotations>(ans = new Annotations(AnnotationParser.parseAnnotations(method)));
	}
	return ans;
}

public <T extends Annotation> T getAnnotation(Class<T> cl) {
	if (cl == null) throw new NullPointerException();
	return getAnnotations().getAnnotation(cl);
}

public Annotation[] getDeclaredAnnotations() {
	return getAnnotations().getAnnotations().clone();
}

public Object getDefaultValue() {
	Object defaultValue;
	synchronized(this) {
		if (srDefaultValue == null || (defaultValue = srDefaultValue.get()) == null) {
			srDefaultValue = new SoftReference<Object>(defaultValue = AnnotationParser.parseDefaultValue(method));
		}
	}
	return defaultValue;
}

public Annotation[][] getParameterAnnotations() {
	return AnnotationParser.parseParameterAnnotations(method);
}

}
